sc::R12IntEvalInfo Class Reference

Class R12IntEvalInfo contains information necessary for R12 intermediate evaluators. More...

`#include <vxb_eval_info.h>`

Inheritance diagram for sc::R12IntEvalInfo:
[legend]
Collaboration diagram for sc::R12IntEvalInfo:
[legend]

## Public Types

enum | StoreMethod { mem_posix = 0, posix = 1, mem_mpi = 2, mpi = 3, mem_only = 4 }
| Describes the method of storing transformed MO integrals. See MBPT2_R12.

## Public Member Functions

| R12IntEvalInfo (StateIn &)
| R12IntEvalInfo (MBPT2_R12 *)
| Constructs an R12IntEvalInfo object using data from the MBPT2_R12 object.
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
void | set_dynamic (bool dynamic)
| Sets whether to use dynamic load balancing in parallel MO transformations. More...
void | set_print_percent (double print_percent)
| Sets how frequently updates of progress are printed out. Default is 10%.
void | set_debug_level (int debug)
| Set debug level. Default is 0.
void | set_ints_method (const StoreMethod method)
| Sets the method of storing transformed MO integrals. More...
void | set_ints_file (const std::string &filename)
| Sets name of the file used to store transformed integrals. More...
void | set_memory (const size_t nbytes)
| Sets the amount of memory to use for the calculation. More...
void | set_absmethod (LinearR12::ABSMethod abs_method)
| Sets the ABS approach to be used (ABS or CABS). More...
Wavefunction * | wfn () const
Ref< SCF > | ref () const
Ref< Integral > | integral () const
Ref< GaussianBasisSet > | basis () const
| Returns the orbital basis set (OBS) object.
Ref< GaussianBasisSet > | basis_vir () const
| Returns the virtuals basis set (VBS) object.
Ref< GaussianBasisSet > | basis_ri () const
| Returns the resolution-of-the-identity basis set (RIBS) object.
Ref< SCMatrixKit > | matrixkit () const
Ref< MemoryGrp > | mem () const
Ref< MessageGrp > | msg () const
Ref< ThreadGrp > | thr () const
bool | dynamic () const
double | print_percent () const
int | debug_level () const
const StoreMethod | ints_method () const
const std::string & | ints_file () const
const size_t | memory () const
const int | nocc () const
const int | nocc_act () const
const int | nfzc () const
const int | nvir () const
const int | nvir_act () const
const int | nfzv () const
LinearR12::ABSMethod | abs_method () const
Ref< MOIndexSpace > | mo_space () const
| Returns the MOIndexSpace object for symmetry-blocked MOs in OBS.
Ref< MOIndexSpace > | obs_space () const
| Returns the MOIndexSpace object for energy-sorted MOs in OBS.
Ref< MOIndexSpace > | act_occ_space () const
| Returns the MOIndexSpace object for the active occupied MOs.
Ref< MOIndexSpace > | act_vir_space () const
| Returns the MOIndexSpace object for the active unoccupied MOs.
Ref< MOIndexSpace > | occ_space () const
| Returns the MOIndexSpace object for all occupied MOs sorted by energy.
Ref< MOIndexSpace > | occ_space_symblk () const
| Returns the MOIndexSpace object for all occupied MOs symmetry-blocked.
Ref< MOIndexSpace > | vir_space () const
| Returns the MOIndexSpace object for all unoccupied MOs ordered by energy.
Ref< MOIndexSpace > | vir_space_symblk () const
| Returns the MOIndexSpace object for all unoccupied MOs ordered by symmetry.
Ref< MOIndexSpace > | abs_space () const
| Returns the MOIndexSpace object for ABS.
Ref< MOIndexSpace > | ribs_space () const
| Returns the MOIndexSpace object for RI-BS.
Ref< MOIntsTransformFactory > | tfactory () const
| Returns the MOIntsTransformFactory object.
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the object.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Static Public Member Functions

static Ref< MOIndexSpace > | orthog_comp (const Ref< MOIndexSpace > &space1, const Ref< MOIndexSpace > &space2, const std::string &name, double lindep_tol)
| Compute subspace of space2 which is orthogonal complement to space1.
static Ref< MOIndexSpace > | orthogonalize (const std::string &name, const Ref< GaussianBasisSet > &bs, const Ref< Integral > &integral, OverlapOrthog::OrthogMethod orthog_method, double lindep_tol, int &nlindep)
| Compute span of bs and create corresponding mospace referred to by name. More...
static Ref< MOIndexSpace > | gen_project (const Ref< MOIndexSpace > &space1, const Ref< MOIndexSpace > &space2, const std::string &name, double lindep_tol)
| Project space1 on space2. More...
static void | compute_overlap_ints (const Ref< MOIndexSpace > &space1, const Ref< MOIndexSpace > &space2, RefSCMatrix &S)
| Compute overlap matrices in the basis of space1 and space2.
static void | compute_multipole_ints (const Ref< MOIndexSpace > &space1, const Ref< MOIndexSpace > &space2, RefSCMatrix &MX, RefSCMatrix &MY, RefSCMatrix &MZ, RefSCMatrix &MXX, RefSCMatrix &MYY, RefSCMatrix &MZZ)
| Compute electric dipole and quadrupole moment matrices in the basis of space1 and space2.
Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)

## Additional Inherited Members

Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Detailed Description

Class R12IntEvalInfo contains information necessary for R12 intermediate evaluators.

## Member Function Documentation

static Ref<MOIndexSpace> sc::R12IntEvalInfo::gen_project | ( | const Ref< MOIndexSpace > & | space1,
|  | const Ref< MOIndexSpace > & | space2,
|  | const std::string & | name,
|  | double | lindep_tol
| ) |  |

static

Project space1 on space2.

This routine computes X2 such that C1.S12.X2 = I, where I is identity matrix and X2 spans subspace of space2. X2 is returned.

static Ref<MOIndexSpace> sc::R12IntEvalInfo::orthogonalize | ( | const std::string & | name,
|  | const Ref< GaussianBasisSet > & | bs,
|  | const Ref< Integral > & | integral,
|  | OverlapOrthog::OrthogMethod | orthog_method,
|  | double | lindep_tol,
|  | int & | nlindep
| ) |  |

static

Compute span of bs and create corresponding mospace referred to by name.

Number linear dependencies is returned in nlindep

void sc::R12IntEvalInfo::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

void sc::R12IntEvalInfo::set_absmethod | ( | LinearR12::ABSMethod | abs_method | ) |

Sets the ABS approach to be used (ABS or CABS).

Default depends on how the object was constructed.

void sc::R12IntEvalInfo::set_dynamic | ( | bool | dynamic | ) |

inline

Sets whether to use dynamic load balancing in parallel MO transformations.

Default is no

void sc::R12IntEvalInfo::set_ints_file | ( | const std::string & | filename | ) |

inline

Sets name of the file used to store transformed integrals.

Default depends on how the object was constructed.

void sc::R12IntEvalInfo::set_ints_method | ( | const StoreMethod | method | ) |

inline

Sets the method of storing transformed MO integrals.

Default depends on how the object was constructed.

void sc::R12IntEvalInfo::set_memory | ( | const size_t | nbytes | ) |

Sets the amount of memory to use for the calculation.

Default is determined by DEFAULT_SC_MEMORY.

The documentation for this class was generated from the following file:

- vxb_eval_info.h